Index: main/plugin-survey/resources/js/org/ametys/survey/SurveyAction.i18n.js
===================================================================
--- main/plugin-survey/resources/js/org/ametys/survey/SurveyAction.i18n.js	(revision 45795)
+++ main/plugin-survey/resources/js/org/ametys/survey/SurveyAction.i18n.js	(working copy)
@@ -349,6 +349,8 @@
 	    form.findField('label').focus(true);
 	    form.findField('label').clearInvalid();
 	    form.findField('title').setValue('');
+	    form.findField('picture').setValue(null);
+	    form.findField('picture-alternative').setValue('');
 	    form.findField('description').setValue('');
 	    form.findField('endingMessage').setValue('');
 	    form.findField('private').setValue(false);
@@ -379,13 +381,47 @@
 		var description = response.selectSingleNode('survey/description') != null ? response.selectSingleNode('survey/description')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var endingMessage = response.selectSingleNode('survey/endingMessage') != null ? response.selectSingleNode('survey/endingMessage')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var isPrivate = response.selectSingleNode('survey').getAttribute('private') == 'true';
-	    
-	    form.findField('id').setValue(id);
+		var picAlternative = response.selectSingleNode('survey/pictureAlternative') != null ? response.selectSingleNode('survey/pictureAlternative')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
+
+		form.findField('id').setValue(id);
 	    form.findField('title').setValue(title);
 	    form.findField('label').setValue(label);
 	    form.findField('description').setValue(description);
 	    form.findField('endingMessage').setValue(endingMessage);
 	    form.findField('private').setValue(isPrivate);
+	    form.findField('picture-alternative').setValue(picAlternative);
+	    
+	    var pictureNode = response.selectSingleNode('survey/picture');
+		if (pictureNode != null)
+		{
+			var picType = pictureNode.getAttribute("pictureType");
+			if (picType == 'resource')
+			{
+				var resourceId = pictureNode.getAttribute('pictureId');
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.web.helper.ChooseResourcesFile.getViewHref(resourceId); 
+				var downloadHref = org.ametys.web.helper.ChooseResourcesFile.getDownloadHref(resourceId);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'resource');
+			}
+			else if (picType == 'external')
+			{
+				var picPath = pictureNode.getAttribute('picturePath') || '';
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.cms.utils.ResourcesUtility.getViewHref(id, picPath);
+				var downloadHref = org.ametys.cms.utils.ResourcesUtility.getDownloadHref(id, picPath);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'external');
+			}
+			else
+			{
+				form.findField('picture').setValue(null);
+			}
+		}
 	}
 }
 
@@ -420,6 +456,19 @@
 					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_SURVEY_TITLE_DESC"/>",
 				     width: 350
 				 }),
+				 new org.ametys.web.widgets.ExternalOrResourceImagesWidget({
+	                 name: 'picture',
+	                 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PICTURE_LABEL"/>",
+	                 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PICTURE_DESC"/>",
+	                 width: 350,
+	                 labelStyle: "height: 100px;"
+	             }),
+	             new org.ametys.form.TextField({
+	                 name: 'picture-alternative',
+	                 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PICTURE_ALT_LABEL"/>",
+	                 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PICTURE_ALT_DESC"/>",
+	                 width: 350
+	             }),
 				 new org.ametys.form.TextAreaField ({
 					 name: 'description',
 					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_SURVEY_DESCRIPTION"/>",
@@ -450,8 +499,8 @@
 		icon : getPluginResourcesUrl(org.ametys.survey.Survey.pluginName) + "/img/survey/survey_16.png",
 		
 		layout :'fit',
-		width : 550,
-		height : 440,
+		width : 570,
+		height : 600,
 		
 		items : [ formPanel ],
 		
@@ -814,6 +863,8 @@
 		form.findField('title').setValue('');
 	    form.findField('description').setValue('');
 	    form.findField('surveyId').setValue(surveyID);
+	    form.findField('picture').setValue(null);
+	    form.findField('picture-alternative').setValue('');
 	}
 	else
 	{
@@ -846,12 +897,46 @@
 		var label = response.selectSingleNode('page/label')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var title = response.selectSingleNode('page/title')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var description = response.selectSingleNode('page/description')[org.ametys.servercomm.ServerComm.xmlTextContent];
+		var picAlternative = response.selectSingleNode('page/pictureAlternative') != null ? response.selectSingleNode('page/pictureAlternative')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 	    
 		var form = org.ametys.survey.Page._form;
 	    form.findField('id').setValue(id);
 	    form.findField('label').setValue(label);
 	    form.findField('title').setValue(title);
 	    form.findField('description').setValue(description);
+	    form.findField('picture-alternative').setValue(picAlternative);
+	    
+	    var pictureNode = response.selectSingleNode('page/picture');
+		if (pictureNode != null)
+		{
+			var picType = pictureNode.getAttribute("pictureType");
+			if (picType == 'resource')
+			{
+				var resourceId = pictureNode.getAttribute('pictureId');
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.web.helper.ChooseResourcesFile.getViewHref(resourceId); 
+				var downloadHref = org.ametys.web.helper.ChooseResourcesFile.getDownloadHref(resourceId);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'resource');
+			}
+			else if (picType == 'external')
+			{
+				var picPath = pictureNode.getAttribute('picturePath') || '';
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.cms.utils.ResourcesUtility.getViewHref(id, picPath);
+				var downloadHref = org.ametys.cms.utils.ResourcesUtility.getDownloadHref(id, picPath);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'external');
+			}
+			else
+			{
+				form.findField('picture').setValue(null);
+			}
+		}
 	}
 }
 
@@ -889,6 +974,19 @@
 					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_TITLE_DESC"/>",
 				     width: 350
 				 }),
+				 new org.ametys.web.widgets.ExternalOrResourceImagesWidget({
+	                 name: 'picture',
+	                 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_PICTURE_LABEL"/>",
+	                 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_PICTURE_DESC"/>",
+	                 width: 350,
+	                 labelStyle: "height: 100px;"
+	             }),
+	             new org.ametys.form.TextField({
+	                 name: 'picture-alternative',
+	                 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_PICTURE_ALT_LABEL"/>",
+	                 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_PICTURE_ALT_DESC"/>",
+	                 width: 350
+	             }),
 				 new org.ametys.form.TextAreaField ({
 					 name: 'description',
 					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_PAGE_DESCRIPTION"/>",
@@ -906,8 +1004,8 @@
 		icon : getPluginResourcesUrl(org.ametys.survey.Page.pluginName) + "/img/pages/page_16.png",
 		
 		layout :'fit',
-		width : 550,
-		height : 270,
+		width : 570,
+		height : 430,
 		
 		items : [ formPanel ],
 		
Index: main/plugin-survey/resources/js/org/ametys/survey/questions/InputChoices.i18n.js
===================================================================
--- main/plugin-survey/resources/js/org/ametys/survey/questions/InputChoices.i18n.js	(revision 45795)
+++ main/plugin-survey/resources/js/org/ametys/survey/questions/InputChoices.i18n.js	(working copy)
@@ -58,6 +58,8 @@
 		form.findField('mandatory').setValue(false);
 		form.findField('multiple').setValue(false);
 		form.findField('other-option').setValue(false);
+		form.findField('picture').setValue(null);
+	    form.findField('picture-alternative').setValue('');
 		
 		org.ametys.survey.question.InputChoices._load('');
 	}
@@ -80,6 +82,7 @@
 		var title = response.selectSingleNode('question/title')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var label = response.selectSingleNode('question/label')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var mandatory = response.selectSingleNode('question').getAttribute('mandatory') == 'true';
+		var picAlternative = response.selectSingleNode('question/pictureAlternative') != null ? response.selectSingleNode('question/pictureAlternative')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var modifiable = response.selectSingleNode('question').getAttribute('modifiable') == 'true';
 		var type = response.selectSingleNode('question').getAttribute('type');
 		var multiple = type == 'MULTIPLE_CHOICE';
@@ -94,7 +97,40 @@
 	    form.findField('multiple').setValue(multiple);
 	    form.findField('other-option').setValue(other);
 	    form.findField('other-option').setDisabled(!modifiable);
+	    form.findField('picture-alternative').setValue(picAlternative);
 	    
+	    var pictureNode = response.selectSingleNode('question/picture');
+		if (pictureNode != null)
+		{
+			var picType = pictureNode.getAttribute("pictureType");
+			if (picType == 'resource')
+			{
+				var resourceId = pictureNode.getAttribute('pictureId');
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.web.helper.ChooseResourcesFile.getViewHref(resourceId); 
+				var downloadHref = org.ametys.web.helper.ChooseResourcesFile.getDownloadHref(resourceId);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'resource');
+			}
+			else if (picType == 'external')
+			{
+				var picPath = pictureNode.getAttribute('picturePath') || '';
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.cms.utils.ResourcesUtility.getViewHref(id, picPath);
+				var downloadHref = org.ametys.cms.utils.ResourcesUtility.getDownloadHref(id, picPath);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'external');
+			}
+			else
+			{
+				form.findField('picture').setValue(null);
+			}
+		}
+		
 	    var options = "";
 	    var optNodes = response.selectNodes('question/options/option');
     	for (var i = 0; i &lt; optNodes.length; i++)
@@ -175,7 +211,7 @@
     
 	org.ametys.survey.question.InputChoices._form = new Ext.FormPanel({
 		region: 'north',
-		height: 180,
+		height: 350,
 		labelWidth: 70,
 		bodyStyle: 'padding:10px',
 		
@@ -198,6 +234,19 @@
 				     maxLength: 20,
 				     width: 300
 				 }),
+				 new org.ametys.web.widgets.ExternalOrResourceImagesWidget({
+					 name: 'picture',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_DESC"/>",
+					 width: 300,
+					 labelStyle: "height: 100px;"
+				 }),
+				 new org.ametys.form.TextField({
+					 name: 'picture-alternative',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_DESC"/>",
+					 width: 300
+				 }),
 				 new org.ametys.form.TextField ({
 					 name: 'title',
 					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_TITLE"/>",
@@ -271,7 +320,7 @@
 
 		layout: 'border',
 		width: 500,
-		height: 460,
+		height: 630,
 		
 		items: [ org.ametys.survey.question.InputChoices._form,
 				 org.ametys.survey.question.InputChoices._grid
Index: main/plugin-survey/resources/js/org/ametys/survey/questions/InputText.i18n.js
===================================================================
--- main/plugin-survey/resources/js/org/ametys/survey/questions/InputText.i18n.js	(revision 45795)
+++ main/plugin-survey/resources/js/org/ametys/survey/questions/InputText.i18n.js	(working copy)
@@ -60,6 +60,8 @@
 		form.findField('multiline').setValue(false);
 		form.findField('regexp').setValue('');
 		form.findField('regexp').enable();
+		form.findField('picture').setValue(null);
+	    form.findField('picture-alternative').setValue('');
 	}
 	else
 	{
@@ -80,6 +82,7 @@
 		var title = response.selectSingleNode('question/title')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var label = response.selectSingleNode('question/label')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var mandatory = response.selectSingleNode('question').getAttribute('mandatory') == 'true';
+		var picAlternative = response.selectSingleNode('question/pictureAlternative') != null ? response.selectSingleNode('question/pictureAlternative')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var regexp = response.selectSingleNode('question/regexp') != null ? response.selectSingleNode('question/regexp')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var type = response.selectSingleNode('question').getAttribute('type');
 		var multiline = type == 'MULTILINE_FREE_TEXT';
@@ -93,6 +96,39 @@
 	    form.findField('multiline').setValue(multiline);
 		form.findField('regexp').setValue(regexp);
 		form.findField('regexp').setDisabled(multiline);
+		form.findField('picture-alternative').setValue(picAlternative);
+	    
+	    var pictureNode = response.selectSingleNode('question/picture');
+		if (pictureNode != null)
+		{
+			var picType = pictureNode.getAttribute("pictureType");
+			if (picType == 'resource')
+			{
+				var resourceId = pictureNode.getAttribute('pictureId');
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.web.helper.ChooseResourcesFile.getViewHref(resourceId); 
+				var downloadHref = org.ametys.web.helper.ChooseResourcesFile.getDownloadHref(resourceId);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'resource');
+			}
+			else if (picType == 'external')
+			{
+				var picPath = pictureNode.getAttribute('picturePath') || '';
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.cms.utils.ResourcesUtility.getViewHref(id, picPath);
+				var downloadHref = org.ametys.cms.utils.ResourcesUtility.getDownloadHref(id, picPath);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'external');
+			}
+			else
+			{
+				form.findField('picture').setValue(null);
+			}
+		}
 	}
 }
 
@@ -126,6 +162,19 @@
 				     maxLength: 20,
 				     width: 340
 				 }),
+				 new org.ametys.web.widgets.ExternalOrResourceImagesWidget({
+					 name: 'picture',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_DESC"/>",
+					 width: 340,
+					 labelStyle: "height: 100px;"
+				 }),
+				 new org.ametys.form.TextField({
+					 name: 'picture-alternative',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_DESC"/>",
+					 width: 340
+				 }),
 				 new org.ametys.form.TextField ({
 					 name: 'title',
 					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_TITLE"/>",
@@ -158,7 +207,7 @@
 		
 		layout :'fit',
 		width : 510,
-		height : 240,
+		height : 410,
 		
 		items : [ formPanel ],
 		
Index: main/plugin-survey/resources/js/org/ametys/survey/questions/Matrix.i18n.js
===================================================================
--- main/plugin-survey/resources/js/org/ametys/survey/questions/Matrix.i18n.js	(revision 45795)
+++ main/plugin-survey/resources/js/org/ametys/survey/questions/Matrix.i18n.js	(working copy)
@@ -58,6 +58,8 @@
 		form.findField('title').clearInvalid();
 		form.findField('mandatory').setValue(false);
 		form.findField('multiple').setValue(false);
+		form.findField('picture').setValue(null);
+	    form.findField('picture-alternative').setValue('');
 		
 		org.ametys.survey.question.Matrix._load('', '');
 	}
@@ -80,6 +82,7 @@
 		var title = response.selectSingleNode('question/title')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var label = response.selectSingleNode('question/label')[org.ametys.servercomm.ServerComm.xmlTextContent];
 		var mandatory = response.selectSingleNode('question').getAttribute('mandatory') == 'true';
+		var picAlternative = response.selectSingleNode('question/pictureAlternative') != null ? response.selectSingleNode('question/pictureAlternative')[org.ametys.servercomm.ServerComm.xmlTextContent] : '';
 		var type = response.selectSingleNode('question').getAttribute('type');
 		var multiple = type == 'MULTIPLE_MATRIX';
 		var modifiable = response.selectSingleNode('question').getAttribute('modifiable') == 'true';
@@ -91,7 +94,40 @@
 	    form.findField('label').setValue(label);
 	    form.findField('mandatory').setValue(mandatory);
 	    form.findField('multiple').setValue(multiple);
+	    form.findField('picture-alternative').setValue(picAlternative);
 	    
+	    var pictureNode = response.selectSingleNode('question/picture');
+		if (pictureNode != null)
+		{
+			var picType = pictureNode.getAttribute("pictureType");
+			if (picType == 'resource')
+			{
+				var resourceId = pictureNode.getAttribute('pictureId');
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.web.helper.ChooseResourcesFile.getViewHref(resourceId); 
+				var downloadHref = org.ametys.web.helper.ChooseResourcesFile.getDownloadHref(resourceId);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'resource');
+			}
+			else if (picType == 'external')
+			{
+				var picPath = pictureNode.getAttribute('picturePath') || '';
+				var picName = pictureNode.getAttribute('pictureName') || '';
+				var picSize = pictureNode.getAttribute('pictureSize') || '';
+				
+				var viewHref = org.ametys.cms.utils.ResourcesUtility.getViewHref(id, picPath);
+				var downloadHref = org.ametys.cms.utils.ResourcesUtility.getDownloadHref(id, picPath);
+				
+				form.findField('picture').setFileValue('untouched', picName, picSize, viewHref, downloadHref, 'external');
+			}
+			else
+			{
+				form.findField('picture').setValue(null);
+			}
+		}
+		
 	    var options = "";
 	    var optNodes = response.selectNodes('question/options/option');
     	for (var i = 0; i &lt; optNodes.length; i++)
@@ -229,7 +265,7 @@
     
 	org.ametys.survey.question.Matrix._form = new Ext.FormPanel({
 		region: 'north',
-		height: 150,
+		height: 320,
 		labelWidth: 70,
 		bodyStyle: 'padding:10px',
 		
@@ -252,6 +288,19 @@
 				     maxLength: 20,
 				     width: 300
 				 }),
+				 new org.ametys.web.widgets.ExternalOrResourceImagesWidget({
+					 name: 'picture',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_DESC"/>",
+					 width: 300,
+					 labelStyle: "height: 100px;"
+				 }),
+				 new org.ametys.form.TextField({
+					 name: 'picture-alternative',
+					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_LABEL"/>",
+					 desc: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_PICTURE_ALT_DESC"/>",
+					 width: 300
+				 }),
 				 new org.ametys.form.TextField ({
 					 name: 'title',
 					 fieldLabel: "<i18n:text i18n:key="PLUGINS_SURVEY_DIALOG_QUESTION_TITLE"/>",
@@ -358,7 +407,7 @@
 
 		layout: 'border',
 		width: 500,
-		height: 450,
+		height: 620,
 		
 		items: [ org.ametys.survey.question.Matrix._form,
 		         new Ext.Panel ({
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/AbstractSurveyAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/AbstractSurveyAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/AbstractSurveyAction.java	(working copy)
@@ -19,31 +19,49 @@
 
 import javax.jcr.RepositoryException;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
 import org.apache.avalon.framework.service.ServiceException;
 import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.SourceResolver;
 
 import org.ametys.cms.observation.AbstractNotifierAction;
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.repository.jcr.JCRAmetysObject;
+import org.ametys.runtime.upload.UploadManager;
 import org.ametys.web.repository.site.SiteManager;
 
 /**
  * Abstract action for manipulate survey
  *
  */
-public abstract class AbstractSurveyAction extends AbstractNotifierAction
+public abstract class AbstractSurveyAction extends AbstractNotifierAction implements Contextualizable
 {
     /** The site manager */
     protected SiteManager _siteManager;
     
+    /** The upload manager. */
+    protected UploadManager _uploadManager;
+    
+    /** The cocoon environment context. */
+    protected Context _context;
+    
+    @Override
+    public void contextualize(org.apache.avalon.framework.context.Context context) throws ContextException
+    {
+        _context = (Context) context.get(Constants.CONTEXT_ENVIRONMENT_CONTEXT);
+    }
+    
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
         super.service(serviceManager);
         _siteManager = (SiteManager) serviceManager.lookup(SiteManager.ROLE);
+        _uploadManager = (UploadManager) serviceManager.lookup(UploadManager.ROLE);
     }
     
     @Override
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/AddPageAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/AddPageAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/AddPageAction.java	(working copy)
@@ -18,17 +18,26 @@
 import java.util.HashMap;
 import java.util.Map;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
 
 import org.ametys.cms.FilterNameHelper;
 import org.ametys.cms.observation.Event;
 import org.ametys.plugins.survey.SurveyEvents;
 import org.ametys.plugins.survey.repository.Survey;
 import org.ametys.plugins.survey.repository.SurveyPage;
+import org.ametys.runtime.upload.Upload;
+import org.ametys.runtime.upload.UploadManager;
 
 /** 
  * This class creates a new survey
@@ -51,6 +60,9 @@
         String title = request.getParameter("title");
         String description = request.getParameter("description");
         String originalName = FilterNameHelper.filterName(label);
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         // Find unique name
         String name = originalName;
@@ -65,6 +77,28 @@
         page.setLabel(label);
         page.setDescription(description);
         
+        if (StringUtils.isEmpty(pictureId))
+        {
+            // Deletion.
+            page.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            page.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            page.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        page.setPictureAlternative(pictureAlternative);
+        
         result.put("id", page.getId());
         
         survey.saveChanges();
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/AddQuestionAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/AddQuestionAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/AddQuestionAction.java	(working copy)
@@ -19,7 +19,13 @@
 import java.util.LinkedHashMap;
 import java.util.Map;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
@@ -32,6 +38,8 @@
 import org.ametys.plugins.survey.repository.SurveyPage;
 import org.ametys.plugins.survey.repository.SurveyQuestion;
 import org.ametys.plugins.survey.repository.SurveyQuestion.QuestionType;
+import org.ametys.runtime.upload.Upload;
+import org.ametys.runtime.upload.UploadManager;
 
 /** 
  * This class creates a new question
@@ -40,6 +48,12 @@
 public class AddQuestionAction extends AbstractSurveyAction
 {
     @Override
+    public void contextualize(org.apache.avalon.framework.context.Context context) throws ContextException
+    {
+        _context = (Context) context.get(Constants.CONTEXT_ENVIRONMENT_CONTEXT);
+    }
+    
+    @Override
     public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
     {
         Map<String, String> result = new HashMap<String, String>();
@@ -57,6 +71,9 @@
         String options = request.getParameter("options");
         String columns = request.getParameter("columns");
         boolean otherOption = "true".equals(request.getParameter("other-option"));
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         String originalName = FilterNameHelper.filterName(label);
         
@@ -68,6 +85,29 @@
         question.setTitle(title);
         question.setMandatory(mandatory);
         question.setType(QuestionType.valueOf(type));
+        
+        if (StringUtils.isEmpty(pictureId))
+        {
+            // Deletion.
+            question.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            question.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            question.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        question.setPictureAlternative(pictureAlternative);
+        
         if (StringUtils.isNotEmpty(regexp))
         {
             question.setRegExpType(regexp);
